BEGIN {
#  if (mode != "check") {
#    if (mode != "change") {
#      print "mode is not correct";
#      exit;
#    }
#  }
  normalLine             = 0;
  comment_1_BeginIsFound = 1;
  comment_1_EndIsFound   = 2;
  comment_2_BeginIsFound = 3;
  string_1_BeginIsFound  = 4;
  string_1_EndIsFound    = 5;
  string_2_BeginIsFound  = 6;
  string_2_EndIsFound    = 7;
  directiveBeginIsFound  = 8;
  directiveEndIsFound    = 9;

  leftBrace  = "{";
  rightBrace = "}";

  switchState = normalLine;

  D2_normalLine        = 10;
  D2_defaultIsFound    = 11;
  D2_commaIsFound      = 12;
  #fourSpace  = "    ";

  D2_switchState = D2_normalLine;
  theLineBefore ="";

  testIt ="no";
  #testIt ="yes";
} # end of BEGIN

function FirstNoSpace(inLine,    i, lengthOfTheInLine, character, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  lengthOfTheInLine = length(inLine);
  for (i = 1; i <= lengthOfTheInLine; i++) {
    character = substr(inLine, i, 1);
    if (character != " ") {
      firstPLace = i;
      break;
    }
  }
  return firstPLace;
}

function FirstSpaceAway(inLine,    outLine, firstPLace)
{                              # separate local variables from real  parameters  by  extra  spaces
  # looking for first not space character
  firstPLace = FirstNoSpace(inLine);
  outLine = substr(inLine, firstPLace);
  return outLine;
}

function PutIndentation(lengthOfIndentation,          i)
{                                # separate local variables from real  parameters  by  extra  spaces
  indentation = "";
  for (i = 1; i<= lengthOfIndentation; i++) {
    indentation = sprintf("%s ", indentation);
  }
}

function transformTheLine(line,           localLine, numberOfPart, i)
{                                # separate local variables from real  parameters  by  extra  spaces
  localLine = FirstSpaceAway(line);
  if (testIt == "yes") {
    printf("T:localLine=:\n");
    printf("             %s:\n", localLine);
    printf("             123456789=123456789=123456789=123456789=123456789=123456789=123456789=123456789=123456789=123456789=\n");
    printf("                      1         2         3         4         5         6         7         8         9         0\n");
  }
  numberOfPart = lookForParts(localLine);
  if (testIt == "yes") {
    printf("numberOfPart=:%d:\n", numberOfPart);
  }
  if (numberOfPart > 0) {
    for (i = 1; i <= numberOfPart; i++) {
      if (testIt == "yes") {
        printf("T:theParts[%d]=:%s:\n", i, theParts[i]);
      }
      #if (mode == "change") {
      #  printf("%s%s", indentation, fourSpace);
      #  valueNumber = valueNumber + 1;
      #  if (valueNumber == 1) {
      #    printf(": ");
      #  } else {
      #    printf(", ");
      #  }
      #  printf("%s\n", theParts[i]);
      #}
    }
  }
}

function lookForComma(linePart,           parenthesis, whereIsComma, i, lengthOfTheRest, character)
{                                # separate local variables from real  parameters  by  extra  spaces
  # looking for ","
  # looking for "," in the same line but not in a (...)
  if (testIt == "yes") {
    printf("look:linePart=:%s:\n", linePart);
  }
  parenthesis = 0;
  whereIsComma = 0;
  lengthOfTheRest = length(linePart);
  i = 1;
  while (i <= lengthOfTheRest && whereIsComma == 0) {
    character = substr(linePart, i, 1);
    if (testIt == "yes") {
      printf("look:i=%d, character=:%s:parenthesis=%d\n", i, character, parenthesis);
    }
    switch (character) {
    case "(":
    case "<":
      parenthesis = parenthesis + 1;
      break;
    case ")":
    case ">":
      parenthesis = parenthesis - 1;
      break;
    case ",":
      if (parenthesis == 0) {
        whereIsComma = i;
      }
      break;
    default:
      break;
    }
    i = i + 1;
  }
  if (testIt == "yes") {
    printf("look:whereIsComma=:%d:\n", whereIsComma);
  }
  if (whereIsComma == lengthOfTheRest) {
    # [2] D2_commaIsFound
    if (testIt == "yes") {
      printf("switchState(139)(%d) changed to D2_commaIsFound\n", NR);
    }
    switchState = D2_commaIsFound;
  }
  return whereIsComma;
}

function lookForParts(line,           nParts, whereIsComma, temp, restOfTheLine )
{                                # separate local variables from real  parameters  by  extra  spaces
  nParts = 0;
  EOLfound = "no";
  restOfTheLine = line;
  if (testIt == "yes") {
    printf("L0:restOfTheLine=:%s:\n", restOfTheLine);
  }
  while (EOLfound == "no") {
    if (restOfTheLine == "") {
      return nParts ;
    }
    if (testIt == "yes") {
      printf("Lw:restOfTheLine=:%s:\n", restOfTheLine);
    }
    # looking for ","
    whereIsComma = lookForComma(restOfTheLine);
    if (testIt == "yes") {
      printf("Lw:whereIsComma=:%d:\n", whereIsComma);
    }
    nParts = nParts + 1;
    if (whereIsComma == 0) {
      # only one part or last part
      theParts[nParts] = restOfTheLine;
      restOfTheLine = "";
    } else {
      # save the part
      theParts[nParts] = substr(restOfTheLine, 1, whereIsComma - 1);
      # prepare the rest
      temp = substr(restOfTheLine, whereIsComma + 1);
      restOfTheLine = FirstSpaceAway(temp);
      if (testIt == "yes") {
        printf("Lw:restOfTheLine=:%s:\n", restOfTheLine);
      }
    }
  }
}

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  restOfTheLine = theLine;
  lengthOfTheRest = length(restOfTheLine);
  workLine = "";

  while (lengthOfTheRest > 0) {
    if (testIt == "yes") {
      printf("switchState(195)(%d)=%d\n", NR, switchState);
    }
    switch(switchState) {
    case 0: # normalLine
      # first dispatch comment_1/comment_2/string_1/string_2/directive
      whereIsComment_1 = index(restOfTheLine, "/*");
      if (testIt == "yes") {
        printf("whereIsComment_1= %d\n", whereIsComment_1);
      }
      # dispatch it
      if (whereIsComment_1 > 0) {
        # [1]
        if (testIt == "yes") {
          printf("switchState(208)(%d) changed to comment_1_BeginIsFound\n", NR);
        }
        switchState = comment_1_BeginIsFound;
        partBeforeComment = substr(restOfTheLine, 1, whereIsComment_1 - 1);
        if (testIt == "yes") {
          printf("(213)partBeforeComment >>%s<<\n", partBeforeComment);
        }
        workLine = workLine partBeforeComment;
        if (testIt == "yes") {
          printf("(217)workLine >>%s<<:\n", workLine);
        }
        temp = substr(restOfTheLine, whereIsComment_1 + 2);
        restOfTheLine = temp;
        lengthOfTheRest = length(restOfTheLine);
        if (testIt == "yes") {
          printf("%d:(223)restOfTheLine >>%s<<\n", NR, restOfTheLine);
        }
      } else {
        whereIsComment_2 = index(restOfTheLine, "//");
        if (testIt == "yes") {
          printf("whereIsComment_2= %d\n", whereIsComment_2);
        }
        if (whereIsComment_2 > 0) {
          # []
          if (testIt == "yes") {
            printf("switchState(233)(%d) changed to comment_2_BeginIsFound\n", NR);
          }
          switchState = comment_2_BeginIsFound;
          partBeforeComment = substr(restOfTheLine, 1, whereIsComment_2 - 1);
          # remove space(s) at end of the line
          lengthOfThePartBefore = length(partBeforeComment);
          letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          while (letter == " ") {
            tempBuffer = substr(partBeforeComment, 1, lengthOfThePartBefore- 1);
            partBeforeComment = tempBuffer;
            lengthOfThePartBefore = length(partBeforeComment);
            letter = substr(partBeforeComment, lengthOfThePartBefore, 1);
          }
          if (testIt == "yes") {
            printf("(247)partBeforeComment >>%s<<\n", partBeforeComment);
          }
          workLine = workLine partBeforeComment;
          if (testIt == "yes") {
            printf("(251)workLine >>%s<<:\n", workLine);
          }
        } else {
          whereIsString_1 = index(restOfTheLine, "\"");
          if (testIt == "yes") {
            printf("whereIsString_1= %d\n", whereIsString_1);
          }
          whereIsString_2 = index(restOfTheLine, "'");
          if (testIt == "yes") {
            printf("whereIsString_2= %d\n", whereIsString_2);
          }
          if ((whereIsString_1 > 0) && (whereIsString_2 > 0)) {
            if (testIt == "yes") {
              printf("choosing ...\n");
            }
            # check which one is first
            if (whereIsString_1 < whereIsString_2) {
              # whereIsString_1 is first
              whereIsString_2 = 0;
            } else {
              # whereIsString_2 is first
              whereIsString_1 = 0;
            }
          } else {
            # nothing to check
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_1= %d\n", whereIsString_1);
          }
          if (testIt == "yes") {
            printf("after choosing: whereIsString_2= %d\n", whereIsString_2);
          }
          if (whereIsString_1 > 0) {
            # []
            if (testIt == "yes") {
              printf("switchState(286)(%d) changed to string_1_BeginIsFound\n", NR);
            }
            switchState = string_1_BeginIsFound;
            partBeforeString = substr(restOfTheLine, 1, whereIsString_1 - 1);
            if (testIt == "yes") {
              printf("(291)partBeforeString >>%s<<\n", partBeforeString);
            }
            workLine = workLine partBeforeString;
            if (testIt == "yes") {
              printf("(295)workLine >>%s<<:\n", workLine);
            }
            temp = substr(restOfTheLine, whereIsString_1 + 1);
            restOfTheLine = temp;
            lengthOfTheRest = length(restOfTheLine);
            if (testIt == "yes") {
              printf("%d:(301)restOfTheLine >>%s<<\n", NR, restOfTheLine);
            }
          } else {
            whereIsString_2 = index(restOfTheLine, "'");
            if (testIt == "yes") {
              printf("whereIsString_2= %d\n", whereIsString_2);
            }
            if (whereIsString_2 > 0) {
              # []
              if (testIt == "yes") {
                printf("switchState(311)(%d) changed to string_2_BeginIsFound\n", NR);
              }
              switchState = string_2_BeginIsFound;
              partBeforeString = substr(restOfTheLine, 1, whereIsString_2 - 1);
              if (testIt == "yes") {
                printf("(316)partBeforeString >>%s<<\n", partBeforeString);
              }
              workLine = workLine partBeforeString;
              if (testIt == "yes") {
                printf("(320)workLine >>%s<<:\n", workLine);
              }
              temp = substr(restOfTheLine, whereIsString_2 + 1);
              restOfTheLine = temp;
              lengthOfTheRest = length(restOfTheLine);
              if (testIt == "yes") {
                printf("%d:(326)restOfTheLine >>%s<<\n", NR, restOfTheLine);
              }
            } else {
              whereIsDirective = index(restOfTheLine, "#define ");
              if (testIt == "yes") {
                printf("whereIsDirective= %d\n", whereIsDirective);
              }
              if (whereIsDirective > 0) {
                # []
                if (testIt == "yes") {
                  printf("switchState(336)(%d) changed to directiveBeginIsFound\n", NR);
                }
                switchState = directiveBeginIsFound;
                temp = substr(restOfTheLine, whereIsDirective + 8);
                restOfTheLine = temp;
                lengthOfTheRest = length(restOfTheLine);
                if (testIt == "yes") {
                  printf("%d:(343)restOfTheLine >>%s<<\n", NR, restOfTheLine);
                }
              } else {
                # it is a normal line
                workLine = workLine restOfTheLine;
                # only for documentation: restOfTheLine = "";
                lengthOfTheRest = 0;
              }
            }
          }
        }
      }
      break;
    case 1: # comment_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(358)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for */
      whereIsCommentEnd = index(restOfTheLine, "*/");
      if (whereIsCommentEnd > 0) {
        # [2]
        if (testIt == "yes") {
          printf("switchState(365)(%d) changed to comment_1_EndIsFound\n", NR);
        }
        switchState = comment_1_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsCommentEnd + 2);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(372)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no comment end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(379)workLine >>%s<<:\n", workLine);
      }
      break;
    case 2: # comment_1_EndIsFound
      if (testIt == "yes") {
        printf("(384)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(388)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 3: # comment_2_BeginIsFound
      # only for documentation: restOfTheLine = "";
      lengthOfTheRest = 0;
      if (testIt == "yes") {
        printf("switchState(396)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 4: # string_1_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(402)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for "
      whereIsStringEnd = index(restOfTheLine, "\"");
      if (whereIsStringEnd > 0) {
        # check the letter before
        letterBefore = substr(restOfTheLine, whereIsStringEnd - 1, 1);
        if (testIt == "yes") {
          printf("%d:(410)letterBefore >>%s<<\n", NR, letterBefore);
        }
        if (letterBefore == "\\") {
          # it is NOT the end of string 
          # no string end found
          # prepare the rest
          temp = substr(restOfTheLine, whereIsStringEnd + 1);
          restOfTheLine = temp;
          if (testIt == "yes") {
            printf("(419)restOfTheLine >>%s<<\n", restOfTheLine);
          }
        } else {
          # []
          if (testIt == "yes") {
            printf("switchState(424)(%d) changed to string_1_EndIsFound\n", NR);
          }
          switchState = string_1_EndIsFound;
          # prepare the rest
          temp = substr(restOfTheLine, whereIsStringEnd + 1);
          restOfTheLine = temp;
          if (testIt == "yes") {
            printf("(431)restOfTheLine >>%s<<\n", restOfTheLine);
          }
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(439)workLine >>%s<<:\n", workLine);
      }
      break;
    case 5: # string_1_EndIsFound
      if (testIt == "yes") {
        printf("(444)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(448)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 6: # string_2_BeginIsFound
      if (testIt == "yes") {
        printf("%d:(454)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for '
      whereIsStringEnd = index(restOfTheLine, "'");
      if (whereIsStringEnd > 0) {
        # []
        if (testIt == "yes") {
          printf("switchState(461)(%d) changed to string_2_EndIsFound\n", NR);
        }
        switchState = string_2_EndIsFound;
        # prepare the rest
        temp = substr(restOfTheLine, whereIsStringEnd + 1);
        restOfTheLine = temp;
        if (testIt == "yes") {
          printf("(468)restOfTheLine >>%s<<\n", restOfTheLine);
        }
      } else {
        # no string end found
        lengthOfTheRest = 0;
      }
      if (testIt == "yes") {
        printf("(475)workLine >>%s<<:\n", workLine);
      }
      break;
    case 7: # string_2_EndIsFound
      if (testIt == "yes") {
        printf("(480)restOfTheLine >>%s<<\n", restOfTheLine);
      }
      lengthOfTheRest = length(restOfTheLine);
      if (testIt == "yes") {
        printf("switchState(484)(%d) changed to normalLine\n", NR);
      }
      switchState = normalLine;
      break;
    case 8: # directiveBeginIsFound
      if (testIt == "yes") {
        printf("%d:(490)restOfTheLine >>%s<<\n", NR, restOfTheLine);
      }
      # looking for \ at the end of the line
      lengthOfTheRest = length(restOfTheLine);
      letter = substr(restOfTheLine, lengthOfTheRest, 1);
      if (letter != "\\") {
        # []
        if (testIt == "yes") {
          printf("switchState(498)(%d) changed to DirectiveEndIsFound\n", NR);
        }
        switchState = directiveEndIsFound;
      } else {
        # the directive goes on on the next line
        lengthOfTheRest = 0;
      }
      break;
    case 9: # directiveEndIsFound
      lengthOfTheRest = 0;
      switchState = normalLine;
      break;
    } # switch(switchState)
  } # while (lengthOfTheRest > 0)
  if (testIt == "yes") {
    printf("(nach while)workLine >>%s<<\n", workLine);
  }

  # look for default part 2
  if (testIt == "yes") {
    printf("D2_switchState(518)(%d)=%d\n", NR, D2_switchState);
  }

  if (testIt == "yes") {
    printf("theLine  >%s<\n", theLine);
    printf("workLine >%s<\n", workLine);
  }
  switch(D2_switchState) {
  case 10: # D2_normalLine:
    # the : is in a new line (Default-1-change.awk does it, or DO it manually!)
    # looking for "  : foo(foo), "
    whereIsDefault = index(workLine, "  :");
    if (testIt == "yes") {
      printf("whereIsDefault >%d<\n", whereIsDefault);
    }
    if (whereIsDefault > 0) {
      # [1]
      if (testIt == "yes") {
        printf("D2_switchState(536)(%d) changed to D2_defaultIsFound\n", NR);
      }
      D2_switchState = D2_defaultIsFound;
      valueNumber = 0;
      # look at the line before
      # TODO: it might be not enough if the parameters are on many lines!!
      if (testIt == "yes") {
        printf("theLineBefore >%s<\n", theLineBefore);
      }
      # looking for first not space character
      lengthOfTheLineBefore = length(theLineBefore);
      for (i = 1; i <= lengthOfTheLineBefore; i++) {
        character = substr(theLineBefore, i, 1);
        if (character != " ") {
          firstPLace = i;
          break;
        }
      }
      if (testIt == "yes") {
        printf("firstPLace=%d\n", firstPLace);
      }
      lengthOfBefore = firstPLace - 1;
      # build the indentation
      PutIndentation(lengthOfBefore);
      if (testIt == "yes") {
        printf("E:indentation=:%s:\n", indentation);
      }
      lastPart = substr(workLine, whereIsDefault + 3);
      if (testIt == "yes") {
        printf("E:lastPart=:%s:\n", lastPart);
      }
      # transform
      theLines = FirstSpaceAway(lastPart);
      if (testIt == "yes") {
        printf("E:theLines=>%s<\n            123456789=123456789=123456789=\n", theLines);
      }
      transformTheLine(theLines);
      #
      # looking for "," at the end of the line
      lineLength = length(theLines);
      whereIsComma = substr(theLines, lineLength, 1);
      if (testIt == "yes") {
        printf("whereIsComma=:%d:\n", whereIsComma);
      }
      if (whereIsComma == lineLength) {
        # [2] D2_commaIsFound
        if (testIt == "yes") {
          printf("D2_switchState(583)(%d) changed to D2_commaIsFound\n", NR);
        }
        D2_switchState = D2_commaIsFound;
      }
    #} else {
    #  if (mode == "change") {
    #    printf("%s\n", theLine);
    #  }
    }
    break;
  case 11: # D2_defaultIsFound
    if (testIt == "yes") {
      printf("D2_switchState(595)(%d)=%d, \n", NR, D2_switchState);
    }
    # looking for leftBrace
    whereIsleftBrace = index(workLine, leftBrace);
    if (whereIsleftBrace > 0) {
      # [1]
      if (testIt == "yes") {
        printf("D2_switchState(602)(%d) changed to D2_normalLine\n", NR);
      }
      D2_switchState = D2_normalLine;
      #if (mode == "change") {
      #  printf("%s\n", theLine);
      #}
    } else {
####function lookForComma(linePart,           parenthesis, whereIsComma, i, lengthOfTheRest, character)
      if (testIt == "yes") {
        printf("the next line of default setting(s):%s:\n", workLine);
      }
      #if (mode == "change") {
      #  temp = FirstSpaceAway(workLine);
      #  printf("%s%s%s\n", indentation, fourSpace, temp);
      #}
    }
    break;
  case 12: # D2_commaIsFound
    if (testIt == "yes") {
      printf("D2_switchState(621)(%d)=%d\n", NR, D2_switchState);
    }
    # looking for leftBrace
    whereIsleftBrace = index(workLine, leftBrace);
    if (whereIsleftBrace > 0) {
      # [1]
      if (testIt == "yes") {
        printf("D2_switchState(628)(%d) changed to D2_normalLine\n", NR);
      }
      D2_switchState = D2_normalLine;
      #if (mode == "change") {
      #  printf("%s\n", theLine);
      #}
    } else {
      line = FirstSpaceAway(workLine);
      first = substr(line, 1, 1);
      if (first == ",") {
        # nothing to do
      } else {
        if (testIt == "yes") {
          printf("the next line of default setting(s):%s:\n", workLine);
        }
        # transform
        transformTheLine(line);
      }
    }
    break;
  }
  theLineBefore = theLine;
}
