BEGIN {
  if (mode != "check") {
    if (mode != "change") {
      print "mode is not correct";
      exit;
    }
  }
  empty_line_found = "no";
  testIt ="no";
  #testIt ="yes";
} # end of BEGIN

{ # do the job
  theLine = $0;
  if (testIt == "yes") {
    printf("\n%d, ====>:%s:\n", NR, theLine);
  }
  # look for empty line
  lengthOfTheLine = length(theLine);
  if (empty_line_found == "no") {
    if (lengthOfTheLine == 0) {
      # this is the first empty line 
      empty_line_found = "yes";
    } else {
      # not an empty line
    }
    if (mode == "change") {
      printf("%s\n", theLine);
    }
  } else {
    # the last line is empty
    if (lengthOfTheLine == 0) {
      # this is the next empty line 
      if (mode == "check") {
        printf("%d: multiple empty line found\n", NR);
      }
    } else {
      # no more empty line
      empty_line_found = "no";
      if (mode == "change") {
        printf("%s\n", theLine);
      }
    }
  }
}
